#ifndef _FMTHEADERS_H
#define _FMTHEADERS_H	1

#include <sys/types.h>

/* Definitions for .VOC files */

#define VOC_MAGIC	"Creative Voice File\032"

#define DATALEN(bp)	((unsigned long)(bp.BlockLen[0]) | \
                         ((unsigned long)(bp.BlockLen[1]) << 8) | \
                         ((unsigned long)(bp.BlockLen[2]) << 16) )

typedef struct vochead {
  unsigned char  Magic[20];	/* must be VOC_MAGIC */
  unsigned short BlockOffset;	/* Offset to first block from top of file */
  unsigned short Version;	/* VOC-file version */
  unsigned short IDCode;	/* complement of version + 0x1234 */
} vochead;

typedef struct blockTC {
  unsigned char  BlockID;
  unsigned char  BlockLen[3];	/* low, mid, high byte of length of rest of block */
} blockTC;

typedef struct blockT1 {
  unsigned char  TimeConstant;
  unsigned char  PackMethod;
} blockT1;

typedef struct blockT8 {
  unsigned short TimeConstant;
  unsigned char  PackMethod;
  unsigned char  VoiceMode;
} blockT8;

typedef struct blockT9 {
  unsigned int   SamplesPerSec;
  unsigned char  BitsPerSample;
  unsigned char  Channels;
  unsigned short Format;
  unsigned char   reserved[4];
} blockT9;
  


/* Definitions for Microsoft WAVE format */

/* it's in chunks like .voc and AMIGA iff, but my source say there
   are in only in this combination, so I combined them in one header;
   it works on all WAVE-file I have
*/
typedef struct wavhead {
  unsigned long	main_chunk;	/* 'RIFF' */
  unsigned long	length;		/* Length of rest of file */
  unsigned long	chunk_type;	/* 'WAVE' */

  unsigned long	sub_chunk;	/* 'fmt ' */
  unsigned long	sc_len;		/* length of sub_chunk, =16 (rest of chunk) */
  unsigned short	format;		/* should be 1 for PCM-code */
  unsigned short	modus;		/* 1 Mono, 2 Stereo */
  unsigned long	sample_fq;	/* frequence of sample */
  unsigned long	byte_p_sec;
  unsigned short	byte_p_spl;	/* samplesize; 1 or 2 bytes */
  unsigned short	bit_p_spl;	/* 8, 12 or 16 bit */ 

  unsigned long	data_chunk;	/* 'data' */
  unsigned long	data_length;	/* samplecount (lenth of rest of block?)*/
} wavhead;

#endif
